import java.io.*;
import java.util.*;
import java.util.regex.*;

        class MLInterpreter
        {
                YYARec[] yya;
                YYARec[] yyg;
                YYRRec[] yyr;
                int[] yyd;
                int[] yyal;
                int[] yyah;
                int[] yygl;
                int[] yygh;

                int yyn = 0;
                int yystate = 0;
                int yychar = -1;
                int yynerrs = 0;
                int yyerrflag = 0;
                int yysp = 0;
                int yymaxdepth = 1024;
                int yyflag = 0;
                int yyfnone   = 0;
                int[] yys = new int[1024];
                String[] yyv = new String[1024];

                String yyval = "";

                public static class TOutput extends PrintWriter { 
                 public TOutput(BufferedWriter b) { super(b); }
                 public TOutput(PrintStream s) { super(s); }
                 public void WriteLine(String s) { println(s); } 
                }
                TOutput Output;

                class YYARec
                {
                        public int sym;
                        public int act;
                        public YYARec (int s, int a){ sym = s; act = a; }
                }

                class YYRRec
                {
                        public int len;
                        public int sym;
                        public YYRRec (int l, int s){ sym = s; len = l; }
                }

                ////////////////////////////////////////////////////////////////
                /// Constant values / tokens
                ////////////////////////////////////////////////////////////////
                int t_Minus = 257;
                int t_A = 258;
                int t_C = 259;
                int t_D = 260;
                int t_E = 261;
                int t_F = 262;
                int t_G = 263;
                int t_H = 264;
                int t_T_0 = 265;
                int t_T_1 = 266;
                int t_T_2 = 267;
                int t_T_16 = 268;
                int t_T_32 = 269;
                int t_T_4 = 270;
                int t_T_8 = 271;
                int t_P = 272;
                int t_ignore = 256;
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////
javax.sound.midi.Synthesizer synth = null;
public void initMidi() {
try {
// Locate the default synthesizer
synth = javax.sound.midi.MidiSystem.getSynthesizer();
// Open the synthesizer
synth.open();
}
catch (Exception exc) {exc.printStackTrace();}
}
public void playNote(int Key, int Duration) {
if (synth == null) initMidi();
try {
// Get the available Midi channels
javax.sound.midi.MidiChannel channels[] = synth.getChannels();
// Play a note on channel 1
if(Key != -1) channels[1].noteOn(Key, 127);
// Give the note some time to play
Thread.sleep(Duration);
// Turn the note off
if(Key != -1) channels[1].noteOff(Key);
}
catch (Exception exc) {exc.printStackTrace();}
}
public void destroyMidi ()
{
try {
// Close the synthesizer device
synth.close();
}
catch (Exception exc) {exc.printStackTrace();}
}

///////////////////////////////////////////////////////////


                /// <summary>
                /// Der Haupteinstiegspunkt fr die Anwendung.
                /// </summary>
                public static void main(String[] args)
                {
                        MLInterpreter compiler = new MLInterpreter();
                        String inputstream = "";

                        boolean ShowTokens = false;
                        String InputFilename = "";
                        String OutputFilename = "";

                        for (String s : args)
                        {
                                if (s.toLowerCase().equals("-t"))
                                {
                                        ShowTokens = true;
                                }
                                else
                                {
                                        if (InputFilename.equals(""))  InputFilename = s; else
                                        if (OutputFilename.equals("")) OutputFilename = s; else
                                        {
                                                System.out.println("Too many arguments!");
                                                System.exit(1);
                                        }
                                }
                        }
                        if (InputFilename.equals(""))
                        {
                                System.out.println("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                                System.exit(1);
                        }

                        try{

						FileInputStream in=new FileInputStream(InputFilename);
						int len=in.available();
						for(int i=1;i<=len;i++)
						{
						   inputstream += (char)in.read();
						}
                        in.close();

                        ////////////////////////////////////////////////////////////////
                        /// Compiler Code:
                        ////////////////////////////////////////////////////////////////

			

                        compiler.Output = null;
                        if (!OutputFilename.equals(""))
                        {
                                File myFile = new File(OutputFilename);
                                myFile.delete();
                                compiler.Output = new TOutput(new BufferedWriter(new FileWriter(OutputFilename)));
                        }
                        else
                        {
                                compiler.Output = new TOutput(System.out);
                        }
                        }catch (Exception e) {e.printStackTrace(); System.exit(1);}

                        if (!compiler.Scanner(inputstream)) System.exit(1);
                        if (ShowTokens)
                        {
                                for (Object o : compiler.TokenList)
                                {
                                        AToken t = (AToken)o;
                                        System.out.println("TokenID: "+t.token+"  =  "+t.val);
                                }
                        }
                        compiler.InitTables();
                        if(!compiler.yyparse()) System.exit(1);

                        if (compiler.Output != null) compiler.Output.close();			
                }
                public void yyaction (int yyruleno)
                {
                        switch (yyruleno)
                        {
                                ////////////////////////////////////////////////////////////////
                                /// YYAction code:
                                ////////////////////////////////////////////////////////////////
							case    1 : 
         // This rule is applied last so we can close the Midi channel here
         destroyMidi();
         
       break;
							case    2 : 
         yyval = yyv[yysp-0];
         
       break;
							case    3 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    4 : 
         int key = 0;
         if (yyv[yysp-2].equals("C0")) key = 60;  if (yyv[yysp-2].equals("C1")) key = 72;
         if (yyv[yysp-2].equals("D0")) key = 62;  if (yyv[yysp-2].equals("D1")) key = 74;
         if (yyv[yysp-2].equals("E0")) key = 64;  if (yyv[yysp-2].equals("E1")) key = 76;
         if (yyv[yysp-2].equals("F0")) key = 65;  if (yyv[yysp-2].equals("F1")) key = 77;
         if (yyv[yysp-2].equals("G0")) key = 67;  if (yyv[yysp-2].equals("G1")) key = 79;
         if (yyv[yysp-2].equals("A0")) key = 69;  if (yyv[yysp-2].equals("A1")) key = 81;
         if (yyv[yysp-2].equals("H0")) key = 71;  if (yyv[yysp-2].equals("H1")) key = 83;
         
         int duration = 0;
         if (yyv[yysp-0].equals("1"))  duration = 1000/1;
         if (yyv[yysp-0].equals("2"))  duration = 1000/2;
         if (yyv[yysp-0].equals("4"))  duration = 1000/4;
         if (yyv[yysp-0].equals("8"))  duration = 1000/8;
         if (yyv[yysp-0].equals("16")) duration = 1000/16;
         if (yyv[yysp-0].equals("32")) duration = 1000/32;
         
         playNote(key,duration);
         
       break;
							case    5 : 
         int pause = 0;
         if (yyv[yysp-0].equals("1"))  pause = 1000/1;
         if (yyv[yysp-0].equals("2"))  pause = 1000/2;
         if (yyv[yysp-0].equals("4"))  pause = 1000/4;
         if (yyv[yysp-0].equals("8"))  pause = 1000/8;
         if (yyv[yysp-0].equals("16")) pause = 1000/16;
         if (yyv[yysp-0].equals("32")) pause = 1000/32;
         
         // -1 for Pause-key
         playNote(-1,pause);
         
       break;
							case    6 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    7 : 
         yyval = yyv[yysp-0];
         
       break;
							case    8 : 
         yyval = yyv[yysp-0];
         
       break;
							case    9 : 
         yyval = yyv[yysp-0];
         
       break;
							case   10 : 
         yyval = yyv[yysp-0];
         
       break;
							case   11 : 
         yyval = yyv[yysp-0];
         
       break;
							case   12 : 
         yyval = yyv[yysp-0];
         
       break;
							case   13 : 
         yyval = yyv[yysp-0];
         
       break;
							case   14 : 
         yyval = yyv[yysp-0];
         
       break;
							case   15 : 
         yyval = yyv[yysp-0];
         
       break;
							case   16 : 
         yyval = yyv[yysp-0];
         
       break;
							case   17 : 
         yyval = yyv[yysp-0];
         
       break;
							case   18 : 
         yyval = yyv[yysp-0];
         
       break;
							case   19 : 
         yyval = yyv[yysp-0];
         
       break;
							case   20 : 
         yyval = yyv[yysp-0];
         
       break;
							case   21 : 
         yyval = yyv[yysp-0];
         
       break;
							case   22 : 
         yyval = yyv[yysp-0];
         
       break;
							case   23 : 
         yyval = yyv[yysp-0];
         
       break;
                                default : return;
                        }
                }

                public void InitTables()
                {
                        ////////////////////////////////////////////////////////////////
                        /// Init Table code:
                        ////////////////////////////////////////////////////////////////

					int yynacts   = 35;
					int yyngotos  = 14;
					int yynstates = 30;
					int yynrules  = 23;
					yya = new YYARec[yynacts+1];  int yyac = 1;
					yyg = new YYARec[yyngotos+1]; int yygc = 1;
					yyr = new YYRRec[yynrules+1]; int yyrc = 1;

					yya[yyac] = new YYARec(258,7);yyac++; 
					yya[yyac] = new YYARec(259,8);yyac++; 
					yya[yyac] = new YYARec(260,9);yyac++; 
					yya[yyac] = new YYARec(261,10);yyac++; 
					yya[yyac] = new YYARec(262,11);yyac++; 
					yya[yyac] = new YYARec(263,12);yyac++; 
					yya[yyac] = new YYARec(264,13);yyac++; 
					yya[yyac] = new YYARec(272,14);yyac++; 
					yya[yyac] = new YYARec(265,16);yyac++; 
					yya[yyac] = new YYARec(266,17);yyac++; 
					yya[yyac] = new YYARec(267,18);yyac++; 
					yya[yyac] = new YYARec(257,19);yyac++; 
					yya[yyac] = new YYARec(257,20);yyac++; 
					yya[yyac] = new YYARec(258,7);yyac++; 
					yya[yyac] = new YYARec(259,8);yyac++; 
					yya[yyac] = new YYARec(260,9);yyac++; 
					yya[yyac] = new YYARec(261,10);yyac++; 
					yya[yyac] = new YYARec(262,11);yyac++; 
					yya[yyac] = new YYARec(263,12);yyac++; 
					yya[yyac] = new YYARec(264,13);yyac++; 
					yya[yyac] = new YYARec(272,14);yyac++; 
					yya[yyac] = new YYARec(0,-2 );yyac++; 
					yya[yyac] = new YYARec(0,0);yyac++; 
					yya[yyac] = new YYARec(266,23);yyac++; 
					yya[yyac] = new YYARec(267,24);yyac++; 
					yya[yyac] = new YYARec(268,25);yyac++; 
					yya[yyac] = new YYARec(269,26);yyac++; 
					yya[yyac] = new YYARec(270,27);yyac++; 
					yya[yyac] = new YYARec(271,28);yyac++; 
					yya[yyac] = new YYARec(266,23);yyac++; 
					yya[yyac] = new YYARec(267,24);yyac++; 
					yya[yyac] = new YYARec(268,25);yyac++; 
					yya[yyac] = new YYARec(269,26);yyac++; 
					yya[yyac] = new YYARec(270,27);yyac++; 
					yya[yyac] = new YYARec(271,28);yyac++;

					yyg[yygc] = new YYARec(-8,1);yygc++; 
					yyg[yygc] = new YYARec(-7,2);yygc++; 
					yyg[yygc] = new YYARec(-5,3);yygc++; 
					yyg[yygc] = new YYARec(-4,4);yygc++; 
					yyg[yygc] = new YYARec(-3,5);yygc++; 
					yyg[yygc] = new YYARec(-2,6);yygc++; 
					yyg[yygc] = new YYARec(-9,15);yygc++; 
					yyg[yygc] = new YYARec(-8,1);yygc++; 
					yyg[yygc] = new YYARec(-7,2);yygc++; 
					yyg[yygc] = new YYARec(-5,3);yygc++; 
					yyg[yygc] = new YYARec(-4,4);yygc++; 
					yyg[yygc] = new YYARec(-3,21);yygc++; 
					yyg[yygc] = new YYARec(-6,22);yygc++; 
					yyg[yygc] = new YYARec(-6,29);yygc++;

					yyd = new int[yynstates];
					yyd[0] = 0;  
					yyd[1] = 0;  
					yyd[2] = 0;  
					yyd[3] = 0;  
					yyd[4] = 0;  
					yyd[5] = -1;  
					yyd[6] = 0;  
					yyd[7] = -7;  
					yyd[8] = -8;  
					yyd[9] = -9;  
					yyd[10] = -10;  
					yyd[11] = -11;  
					yyd[12] = -12;  
					yyd[13] = -13;  
					yyd[14] = -23;  
					yyd[15] = -6;  
					yyd[16] = -14;  
					yyd[17] = -15;  
					yyd[18] = -16;  
					yyd[19] = 0;  
					yyd[20] = 0;  
					yyd[21] = -3;  
					yyd[22] = -5;  
					yyd[23] = -17;  
					yyd[24] = -19;  
					yyd[25] = -18;  
					yyd[26] = -20;  
					yyd[27] = -21;  
					yyd[28] = -22;  
					yyd[29] = -4; 

					yyal = new int[yynstates];
					yyal[0] = 1;  
					yyal[1] = 9;  
					yyal[2] = 12;  
					yyal[3] = 13;  
					yyal[4] = 14;  
					yyal[5] = 23;  
					yyal[6] = 23;  
					yyal[7] = 24;  
					yyal[8] = 24;  
					yyal[9] = 24;  
					yyal[10] = 24;  
					yyal[11] = 24;  
					yyal[12] = 24;  
					yyal[13] = 24;  
					yyal[14] = 24;  
					yyal[15] = 24;  
					yyal[16] = 24;  
					yyal[17] = 24;  
					yyal[18] = 24;  
					yyal[19] = 24;  
					yyal[20] = 30;  
					yyal[21] = 36;  
					yyal[22] = 36;  
					yyal[23] = 36;  
					yyal[24] = 36;  
					yyal[25] = 36;  
					yyal[26] = 36;  
					yyal[27] = 36;  
					yyal[28] = 36;  
					yyal[29] = 36; 

					yyah = new int[yynstates];
					yyah[0] = 8;  
					yyah[1] = 11;  
					yyah[2] = 12;  
					yyah[3] = 13;  
					yyah[4] = 22;  
					yyah[5] = 22;  
					yyah[6] = 23;  
					yyah[7] = 23;  
					yyah[8] = 23;  
					yyah[9] = 23;  
					yyah[10] = 23;  
					yyah[11] = 23;  
					yyah[12] = 23;  
					yyah[13] = 23;  
					yyah[14] = 23;  
					yyah[15] = 23;  
					yyah[16] = 23;  
					yyah[17] = 23;  
					yyah[18] = 23;  
					yyah[19] = 29;  
					yyah[20] = 35;  
					yyah[21] = 35;  
					yyah[22] = 35;  
					yyah[23] = 35;  
					yyah[24] = 35;  
					yyah[25] = 35;  
					yyah[26] = 35;  
					yyah[27] = 35;  
					yyah[28] = 35;  
					yyah[29] = 35; 

					yygl = new int[yynstates];
					yygl[0] = 1;  
					yygl[1] = 7;  
					yygl[2] = 8;  
					yygl[3] = 8;  
					yygl[4] = 8;  
					yygl[5] = 13;  
					yygl[6] = 13;  
					yygl[7] = 13;  
					yygl[8] = 13;  
					yygl[9] = 13;  
					yygl[10] = 13;  
					yygl[11] = 13;  
					yygl[12] = 13;  
					yygl[13] = 13;  
					yygl[14] = 13;  
					yygl[15] = 13;  
					yygl[16] = 13;  
					yygl[17] = 13;  
					yygl[18] = 13;  
					yygl[19] = 13;  
					yygl[20] = 14;  
					yygl[21] = 15;  
					yygl[22] = 15;  
					yygl[23] = 15;  
					yygl[24] = 15;  
					yygl[25] = 15;  
					yygl[26] = 15;  
					yygl[27] = 15;  
					yygl[28] = 15;  
					yygl[29] = 15; 

					yygh = new int[yynstates];
					yygh[0] = 6;  
					yygh[1] = 7;  
					yygh[2] = 7;  
					yygh[3] = 7;  
					yygh[4] = 12;  
					yygh[5] = 12;  
					yygh[6] = 12;  
					yygh[7] = 12;  
					yygh[8] = 12;  
					yygh[9] = 12;  
					yygh[10] = 12;  
					yygh[11] = 12;  
					yygh[12] = 12;  
					yygh[13] = 12;  
					yygh[14] = 12;  
					yygh[15] = 12;  
					yygh[16] = 12;  
					yygh[17] = 12;  
					yygh[18] = 12;  
					yygh[19] = 13;  
					yygh[20] = 14;  
					yygh[21] = 14;  
					yygh[22] = 14;  
					yygh[23] = 14;  
					yygh[24] = 14;  
					yygh[25] = 14;  
					yygh[26] = 14;  
					yygh[27] = 14;  
					yygh[28] = 14;  
					yygh[29] = 14; 

					yyr[yyrc] = new YYRRec(1,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-9);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-7);yyrc++;
                }

                public boolean yyact(int state, int sym)
                {
                        int k = yyal[state];
                        while ( k <= yyah[state] && yya[k].sym != sym) k++;
                        if (k > yyah[state]) return false;
                        yyn = yya[k].act;
                        return true;
                }
                public boolean yygoto(int state, int sym)
                {
                        int k = yygl[state];
                        while ( k <= yygh[state] && yyg[k].sym != sym) k++;
                        if (k > yygh[state]) return false;
                        yyn = yyg[k].act;
                        return true;
                }

                public void yyerror (String s)
                {
                        System.out.println(s);
                }

                int yylexpos = -1;
                String yylval = "";

                public int yylex ()
                {
                        yylexpos++;
                        if(yylexpos >= TokenList.size())
                        {
                                yylval = "";
                                return 0;
                        }
                        else
                        {
                                yylval = ((AToken)TokenList.get(yylexpos)).val;
                                return ((AToken)TokenList.get(yylexpos)).token;
                        }
                }


                public boolean yyparse ()
                {
                        boolean jumpToNext = false;
                        while(true){ // Parse:
                        if (!jumpToNext){
                        yysp++;
                        if (yysp>yymaxdepth)
                        {
                                yyerror("yyparse stack overflow");
                                return false;
                        }

                        yys[yysp] = yystate;
                        yyv[yysp] = yyval;
                        }
                        jumpToNext = false;

                        if (yyd[yystate]==0 && yychar==-1)
                        {
                            yychar = yylex();
                            if (yychar<0) yychar = 0;
                        }

                        yyn = yyd[yystate];
                        if (yyn != 0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }

                        if (! yyact(yystate, yychar)) {
                          if (yyerrflag==0) yyerror("syntax error");
                          int r = yy_errlab();
                          if (r == 0) return false;
                          if (r == 1) continue;
                          if (r == 2) {jumpToNext = true; continue; }
                        }
                        else if (yyn>0) {
                         /// shift:
                         yystate = yyn;
                         yychar = -1;
                         yyval = yylval;
                         if (yyerrflag>0) yyerrflag--;
                         continue; // PARSE:
                         ///////////////
                        }
                        else if (yyn<0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }
                        else return true;
                        } // WHILE Parse:
                }

                public int yy_errlab (){
                        if (yyerrflag==0) yynerrs++;
                        if (yyerrflag<=2)
                        {
                                yyerrflag = 3;
                                while (yysp>0 && !(yyact(yys[yysp], 255) && yyn > 0)) yysp--;

                                if (yysp==0) return 0;
                                yystate = yyn;
                                return 1; // PARSE:
                        }
                        else
                        {
                                if (yychar==0) return 0;
                                yychar = -1;
                                return 2;
                        }
                }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public String val;
		}

		ArrayList<AToken> TokenList = new ArrayList<AToken>();

		public boolean Scanner (String Input)
		{
		        if (Input.length() == 0) return true;
			TokenList = new ArrayList<AToken>();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.add(lasttoken);
				if (Input.length() > lasttoken.val.length())
				Input = Input.substring(lasttoken.val.length()); else return true;
			}
                      System.out.println(Input);
			System.out.println();
			System.out.println("No matching token found!");
			return false;
		}
		public AToken FindToken (String Rest)
		{
			ArrayList<Integer> Results  = new ArrayList<Integer>();
			ArrayList<String> ResultsV = new ArrayList<String>();
                      try{

                        Pattern p;
                        Matcher m;
                      p = Pattern.compile("^(\\-)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_Minus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(A)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_A));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(C)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_C));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(D)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_D));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(E)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_E));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(F)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_F));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(G)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_G));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(H)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_H));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(0)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_0));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(1)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_1));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(2)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_2));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(16)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_16));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(32)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_32));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(4)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_4));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(8)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_T_8));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(P)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_P));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([\\r\\n\\t\\s])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ignore));
				ResultsV.add(m.group());}

			} catch (Exception e) {}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.size(); i++){
				if (ResultsV.get(i).toString().length() > maxlength)
				{
					maxlength = ResultsV.get(i).toString().length();
					besttoken = ((Integer)Results.get(i)).intValue();
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV.get(i).toString();
				}
			}
			return ret;
		}


	}
